﻿using Dto;
using Entities;
using Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Shared.Mapper;

namespace TestEF.Mapper
{
    public class NotepadMapperUnitTest
    {

        private const int _id = 1;
        private const int _userId = 1;
        private const int _inquiryId = 2;
        private const string _notes = "Notes";



        [Fact]
        public void TestDtoToEntity()
        {
            NotepadDTO notepad = new NotepadDTO(_id,_userId,_inquiryId,_notes);
            var notepadEntity = notepad.FromDTOToEntity();

            Assert.NotNull(notepadEntity);
            Assert.IsType<NotepadEntity>(notepadEntity);
            Assert.Equal(0, notepadEntity.Id);
            Assert.Equal(_userId, notepadEntity.UserId);
            Assert.Equal(1, notepadEntity.InquiryId);
            Assert.Equal(_notes, notepadEntity.Notes);

        }

        [Fact]
        public void TestDtoToModel()
        {
            NotepadDTO notepad = new NotepadDTO(_id,_userId,_inquiryId,_notes);
            var notepadMod = notepad.FromDTOToModel();

            Assert.NotNull(notepadMod);
            Assert.IsType<Notepad>(notepadMod);
            Assert.Equal(_id, notepadMod.Id);
            Assert.Equal(_userId, notepadMod.UserId);
            Assert.Equal(_inquiryId, notepadMod.InquiryId);
            Assert.Equal(_notes, notepadMod.Notes);

        }

        [Fact]
        public void TestEntityToDto()
        {
            NotepadEntity notepad = new NotepadEntity(_id, new UserEntity(), _inquiryId, new InquiryEntity(), _notes);
            var NotepadDTO = notepad.FromEntityToDTO();

            Assert.NotNull(NotepadDTO);
            Assert.IsType<NotepadDTO>(NotepadDTO);
            Assert.Equal(0, NotepadDTO.Id);
            Assert.Equal(_userId, NotepadDTO.UserId);
            Assert.Equal(_inquiryId, NotepadDTO.InquiryId);
            Assert.Equal(_notes, NotepadDTO.Notes);
        }

        [Fact]
        public void TestEntityToModel()
        {
            NotepadEntity notepad = new NotepadEntity(_id,new UserEntity(),_inquiryId,new InquiryEntity(),_notes);
            var notepadMod = notepad.FromEntityToModel();

            Assert.NotNull(notepadMod);
            Assert.IsType<Notepad>(notepadMod);
            Assert.Equal(0, notepadMod.Id);
            Assert.Equal(_userId, notepadMod.UserId);
            Assert.Equal(2, notepadMod.InquiryId);
            Assert.Equal(_notes, notepadMod.Notes);
        }



        [Fact]
        public void TestModelToDto()
        {
            Notepad notepad = new Notepad(_id,_userId,_inquiryId,_notes);
            var NotepadDTO = notepad.FromModelToDTO();

            Assert.NotNull(NotepadDTO);
            Assert.IsType<NotepadDTO>(NotepadDTO);
            Assert.Equal(_id, NotepadDTO.Id);
            Assert.Equal(_userId, NotepadDTO.UserId);
            Assert.Equal(_inquiryId, NotepadDTO.InquiryId);
            Assert.Equal(_notes, NotepadDTO.Notes);
        }

        [Fact]
        public void TestModelToEntity()
        {
            Notepad notepad = new Notepad(_id,_userId,_inquiryId,_notes);
            var notepadEntity = notepad.FromModelToEntity();

            Assert.NotNull(notepadEntity);
            Assert.IsType<NotepadEntity>(notepadEntity);
            Assert.Equal(0, notepadEntity.Id);
            Assert.Equal(_userId, notepadEntity.UserId);
            Assert.Equal(1, notepadEntity.InquiryId);
            Assert.Equal(_notes, notepadEntity.Notes);
        }
    }
}
